
namespace Zipr_SDK
{
typedef std::map<libIRDB::Instruction_t*,Zipr_SDK::RangeAddress_t> InstructionLocationMap_t;

enum ZiprPreference {
	None,
	Must,	
};
class Zipr_t;

class ZiprPluginInterface_t
{
	public:
		virtual void PinningBegin()
		{
		}
		virtual void PinningEnd()
		{
		}
		virtual void DollopBegin()
		{
		}
		virtual void DollopEnd()
		{
		}
		virtual void CallbackLinkingBegin()
		{
		}
		virtual void CallbackLinkingEnd()
		{
		}

		virtual ZiprPreference AddressDollop(const Dollop_t *dollop, const RangeAddress_t &source, Range_t &place, bool &coalesce)
		{
			return None;
		}

		virtual bool WillPluginPlop(libIRDB::Instruction_t*)
		{
			return false;
		}
		virtual size_t WorstCaseInsnSize(libIRDB::Instruction_t*, bool, Zipr_t *)
		{
			return 0;
		}
		virtual RangeAddress_t PlopDollopEntry(Zipr_SDK::DollopEntry_t *,
			RangeAddress_t &,
			Zipr_t *)
		{
			return 0;
		}
		virtual std::string ToString()
		{
			return "NamelessPlugin";
		}
		virtual ZiprOptionsNamespace_t *RegisterOptions(ZiprOptionsNamespace_t *)
		{
			return new ZiprOptionsNamespace_t("");
		}

		virtual ZiprPreference RetargetPin(const RangeAddress_t &, const Zipr_SDK::Dollop_t *, RangeAddress_t &)
		{
			return None;
		}
};

}
